#pragma once

#using <System.dll>
#using <System.Windows.Forms.dll>

#include <Windows.h>
#include <vcclr.h>
//#include <sstream>
//
//using namespace std;

using namespace System;
using namespace System::IO;
using namespace System::Reflection;
using namespace System::Windows::Forms;

extern void Log(const wchar_t* msg);

public ref class MyThinWrapper {
public:
	static Type^ fsType;
	static Object^ fso;

	static MyThinWrapper()
	{
		fsType = nullptr;
		fso = nullptr;
	}

	static void _InternalInit()
	{
		//if(System::IO::File::ReadAllText("c:\\temp\\dodebug.t")->Contains("W")) 
		//	System::Windows::Forms::MessageBox::Show("Debug: Starting load of moduleexp.dll.");
		//Log(L"1");
		String^ codeBase = Assembly::GetExecutingAssembly()->CodeBase;
        UriBuilder^ uri = gcnew UriBuilder(codeBase);
        String^ path = Uri::UnescapeDataString(uri->Path);
        String^ dirname = Path::GetDirectoryName(path);
		String^ realpath = gcnew String("moduleexp.dll");
		String^ finalpath = dirname + Path::DirectorySeparatorChar.ToString() + realpath;
	
		//pin_ptr<const wchar_t> wch = PtrToStringChars(finalpath);
		//Log(wch);

		Assembly^ a = Assembly::LoadFrom(finalpath);
		//Log(L"Assembly^ a = Assembly::LoadFrom(finalpath);");
        fsType = a->GetType("MyUtils.FsExports");
		//Log(L"fsType = a->GetType(\"MyUtils.FsExports\");");
		fso = Activator::CreateInstance(fsType);
		//Log(L"fso = Activator::CreateInstance(fsType);");

		//if(fso && System::IO::File::ReadAllText("c:\\temp\\dodebug.t")->Contains("W"))
		//	System::Windows::Forms::MessageBox::Show("Debug: Loaded moduleexp.dll successfully.");
	}

	int Add(int k, int j);
	static int Add2(int k, int j)
	{
		if(fsType == nullptr)
			_InternalInit();

		//Log(L"_InternalInit();");
		int x = (int) (fsType->InvokeMember("Add", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { k, j })); 
		//Log(L"fsType->InvokeMember(\"Add\",...)");
		//std::wstringstream s;
		//s << "Result of calling f# add(), now in c++:" << x;
		Log(L"After calling f# add(), now in c++");

		//System::Diagnostics::Debugger::Break();
		return x;
	}

	static void LoadSettings(String^ abbrXul, bool bUseFavIcon)
	{
		if(fsType == nullptr)
			_InternalInit();
//		::MessageBox(0,0,0,3);
		fsType->InvokeMember("LoadSettings", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { abbrXul, bUseFavIcon });
	}

	static void SetFFIcon(String^ url, String ^title)
	{
		if(fsType == nullptr)
			_InternalInit();
		fsType->InvokeMember("SetFFIcon", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { url, title });
	}
	static void CreateGuid(IntPtr guid)
	{
		if(fsType == nullptr)
			_InternalInit();
		fsType->InvokeMember("CreateGuid", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { guid });
		//MyUtils::FsExports::CreateGuid(guid);
	}
	static bool Init(String^ title)
	{
		if(fsType == nullptr)
			_InternalInit();
		return (bool)(fsType->InvokeMember("Init", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { title }));

		//return false;
		//return MyUtils::FsExports::Init(title);
	}
	static void TestShowIcon(IntPtr iconHandle)
	{
		if(fsType == nullptr)
			_InternalInit();
		fsType->InvokeMember("TestShowIcon", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { iconHandle });
		//MyUtils::FsExports::CreateGuid(guid);
	}
	static void SetSiteFavIcon(String^ url, int data_length, IntPtr icon_data, String^ icon_mime_type)
	{
		if(fsType == nullptr)
			_InternalInit();
		fsType->InvokeMember("SetSiteFavIcon", System::Reflection::BindingFlags::InvokeMethod, nullptr, fso, gcnew array<Object^,1> { url, data_length, icon_data, icon_mime_type });
	}
};
